/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2010 runlevel3 GmbH
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of Rubidium-ClockDistribution.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 * AVR Studio 4.15
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2010 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef onewire_devices_h_
#define onewire_devices_h_

#include <1wire/1wire-manage.h>


//DS18X20
#define CHIP_DS18B20			0x28
#define CHIP_DS18S20			0x10
//commands
#define DS18X20_CONVERT_T		0x44
#define DS18X20_READ			0xBE
#define DS18X20_WRITE			0x4E
#define DS18X20_EE_WRITE		0x48
#define DS18X20_EE_RECALL		0xB8
#define DS18X20_READ_PS			0xB4


typedef struct ds18x20_value
{
	unsigned int raw_temp;
	unsigned char th;
	unsigned char tl;
	unsigned char config;
	unsigned char reserved1;
	unsigned char reserved2;
	unsigned char reserved3;
	unsigned char crc;
} ds18x20_value;

unsigned char ds18x20_init(unsigned char bus_nr, w1_dev *rom);
unsigned char ds18x20_read_ps(unsigned char bus_nr, w1_dev *rom, unsigned char *data);
unsigned char ds18x20_convert(unsigned char bus_nr, w1_dev *rom, unsigned char par_power);
unsigned char ds18x20_read(unsigned char bus_nr, w1_dev *rom);
unsigned char ds18x20_write(unsigned char bus_nr, w1_dev *rom, unsigned char *data);
float ds18x20_compute(w1_dev *rom);


#endif
