/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2010 runlevel3 GmbH
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of Rubidium-ClockDistribution.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 * AVR Studio 4.15
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2010 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef onewire_manage_h_
#define onewire_manage_h_


#define DEV_FLAGS_SCAN			0x08
#define DEV_FLAGS_PARENT_BUS	0x10
#define DEV_FLAGS_NOT_FOUND		0x20
#define DEV_FLAGS_PARASITE_PWR	0x40
#define DEV_FLAGS_AUTO_READ		0x80


//structure for rom-info
typedef struct w1_dev
{
	unsigned char id[8];
	//bits0..2=bus_nr, bit3 main scanned, bit4 aux scanned, bit5 parent main(0)/aux(1), bit6: not found in scan
	unsigned char flags;
	unsigned char err;
	unsigned char *value;
	struct w1_dev *next;
} w1_dev;


w1_dev *find_rom(unsigned char *id);
unsigned char chip_init(unsigned char bus_nr, w1_dev *rom);
w1_dev *create_rom(unsigned char bus_nr, unsigned char *id);
unsigned char search_roms(unsigned char bus_nr, unsigned char master_reset);

#endif
