/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2010 runlevel3 GmbH
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of Rubidium-ClockDistribution.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 * AVR Studio 4.15
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2010 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef onewire_h_
#define onewire_h_


//general 1wire ROM commands
#define MATCH_ROM				0x55
#define SKIP_ROM				0xCC
#define	SEARCH_ROM				0xF0

//constants
#define	SEARCH_FIRST			0xFFFFFFFFFFFFFFFFULL	//start new search
#define LAST_DEVICE				0x00ULL					//last device found
														//0x01..0x40: continue searching

//function prototypes
unsigned char w1_bit_io(unsigned char bus_nr, unsigned char bit);
unsigned char w1_reset(unsigned char bus_nr, unsigned char masterreset);

unsigned char w1_parasite_power(unsigned char bus_nr);
void w1_parasite_power_off(unsigned char bus_nr);

unsigned char w1_byte_wr(unsigned char bus_nr, unsigned char bit);
unsigned char w1_byte_rd(unsigned char bus_nr);

unsigned char w1_rom_search(unsigned char bus_nr, unsigned long long *branch, unsigned char *id);

unsigned char w1_command(unsigned char bus_nr, unsigned char command, unsigned char *id);

#endif
