/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2010 runlevel3 GmbH
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of Rubidium-ClockDistribution.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 * AVR Studio 4.15
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2010 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef config_h_
#define config_h_

//error codes
#define	ERR_HEAT				1

//addresses in FRAM
#define CONFIG_BASE_ADDR		0x1E00
#define CONFIG_BASE_ADDR_ALT	0x1F00
#define	PRESET_MAX				29

//default values
#define CONTRAST_DEFAULT		32
#define DIMON_DEFAULT			120
#define LANGUAGE_DEFAULT		0

//activity timeouts x5ms, max 255
#define REMOTETIMEOUT	200
//pushbutton delay x5ms, max 255
#define PB_DELAY		35
//duration for display error message x5ms, max 65535
#define EMERG_TIMEOUT	12000


typedef struct _config
{
	//power-on-hours counter in seconds
	unsigned long long poh;
	//LCD contrast
	unsigned char contrast;
	unsigned char language;
	unsigned int dim_on;
	unsigned char w1_id_lpro[8];
	unsigned char w1_id_hs[8];
	unsigned int crc16;
} _config;


#endif
