/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2010 runlevel3 GmbH
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of Rubidium-ClockDistribution.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 * AVR Studio 4.15
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2010 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef cy22150_h_
#define cy22150_h_


#define TWI_SLA_CY22150		0xd2		// I2C slave address

#define f_reference_i		10000000ULL	// 10 MHz
#define f_reference			10000000.0	// 10 MHz
#define f_max               200000000ULL   // 200 MHz
#define CAPLOAD_DEFAULT            64
#define XCODRV_DEFAULT              2
#define	FTYPE_F1					1
#define	FTYPE_F2					2
#define	FTYPE_PLL					3
#define	FTYPE_P						4
#define	FTYPE_Q						5



typedef struct pll_settings
{
    double f_ref;                  // reference input frequency
    double f1;                     // requested output divider 1
    double f2;                     // requested output divider 2
    double frac;                   // Abweichung vom Sollwert
    int p;                              // pll-internal value p
    int q;                              // pll-internal value q
    int d1;                             // divider DIV1N
    int d2;                             // divider DIV2N
    int f1_importance;                  // wichtigkeit, 1=wichtig
    int f2_importance;
    int iterations;                     // iterations to find settings
} pll_settings;




void cy22150_init(void);
unsigned long long computefrequency(unsigned char freq_type);
unsigned char checkPLL(void);
void findPLLsettings(pll_settings *pll_vars);
void getOutput(unsigned char output, int *out_src);
void setOutput(unsigned char output, int *out_src);
void getPQD1D2(pll_settings *pll_vars);
void setPQD1D2(pll_settings *pll_vars, unsigned char set_out);
void setChargePump(pll_settings *pll_vars);
void cy22150_buf_write(void);


#endif
