/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2010 runlevel3 GmbH
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of Rubidium-ClockDistribution.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 * AVR Studio 4.15
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2010 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef lcd_alpha_h_
#define lcd_alpha_h_

#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>

//read busy-flag = 1 or use fixed delays = 0
#define	USE_BUSY		1

//control bits
#define	LCD_RS_PORT		PORTA
#define	LCD_RS_DDR		DDRA
#define	LCD_RS_BIT		4
#define	LCD_RW_PORT		PORTA
#define	LCD_RW_DDR		DDRA
#define	LCD_RW_BIT		5
#define	LCD_E_PORT		PORTC
#define	LCD_E_DDR		DDRC
#define	LCD_E_BIT		7
//data port
#define LCD_DATA_PORT	PORTA
#define LCD_DATA_DDR	DDRA
#define LCD_DATA_PIN	PINA
#define LCD_DATA_BIT	0

//panel dimensions
#define	LCD_ROW			2
#define	LCD_COLUMN		16


//Konstanten
#define LCD_CMDDELAY	50
#define LCD_LONGDELAY	2
#define	LCD_MAXCOLUMN	0x40
#define	LCD_RS			1

#define nop() asm volatile ("nop")


void LCD_wait_busy(unsigned char busy);
void LCD_byte_out(unsigned char rs, unsigned char busy, unsigned char data);
unsigned char LCD_byte_in(unsigned char rs);
void LCD_init(void);
void LCD_clear(void);
void LCD_goto(unsigned char row, unsigned char column);
void LCD_putchar(unsigned char data);
void LCD_putstring(unsigned char row, unsigned char column, char *data);

#endif
