/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2010 runlevel3 GmbH
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of Rubidium-ClockDistribution.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 * AVR Studio 4.15
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2010 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef menu_h_
#define menu_h_


//maximal zwei Sprachen
#define	LANG_MAX			2

#define	KEY_1				1
#define	KEY_2				2
#define	KEY_3				3
#define	KEY_4				4
#define	KEY_5				5
#define	KEY_6				6
#define	KEY_7				7
#define	KEY_8				8
#define	KEY_9				9
#define	KEY_0				10
#define	KEY_STAR			11
#define	KEY_RAUTE			12
#define	KEY_RED				16
#define	KEY_GREEN			17
#define	KEY_YELLOW			18
#define	KEY_BLUE			19
#define GRAY_L				32
#define GRAY_R				33
#define	GRAY_PB				34
#define	KEY_DUMMY			99

#define	MENU_ST_IDLE		0
#define	MENU_ST_F1			1
#define	MENU_ST_F2			2
#define	MENU_ST_MENU		3
#define	MENU_ST_VAL			4
#define MENU_ST_ONCE		5

#define	VAL_TYPE_UL			0x00
#define	VAL_TYPE_TEMP		0x01
#define	VAL_TYPE_FREQ		0x02
#define	VAL_TYPE_STRING		0x03
#define	VAL_TYPE_INT		0x04
#define	VAL_TYPE_W1			0x05
#define	VAL_TYPE_POH		0x06
#define	VAL_TYPE_LST		0x40
#define	VAL_TYPE_RO			0x80






typedef struct menuentry
{
	
	char **menu_text;
	struct menuentry *enter;
	struct menuentry *prev;
	struct menuentry *next;
	unsigned long *val;
	unsigned long min;
	unsigned long max;
	unsigned char val_type;
	unsigned char menu_hook;
} menuentry;



struct menuentry *do_menuaction(struct menuentry *m_ptr, struct menuentry *m_entry, unsigned char msg, unsigned char *menustat);




#endif
